//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 21-1 #1
//
// Accepts a command of R(read) or W(write). For write accepts lines of text
// entered until a line with no characters is entered, and saves each line to
// an external SPI EEPROM starting at address 0. for read return the entire
// message to the screen.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>
#define SIZE 100

#define EEPROM_SELECT PIN_B4
#define EEPROM_CLK PIN_B5
#define EEPROM_DI PIN_B6
#define EEPROM_DO PIN_B7

#define EEPROM_ADDRESS long int

#include <9356.c>

int count;

void write(void);
void read(void);

void main(void) {
   
   char c;
   init_ext_eeprom();
   
   for(;;) {
   do {
      printf("\r\nReard or Write (R, W): ");
      c = toupper(getc());
   } while((c != 'R') && (c != 'W'));
   
   if(c == 'R')
      read();
   else
      write();
   
   }
   
   for(;;);
}

void read(void) 
{
   int count;
   int addy = 1;
   
   count = read_ext_eeprom(0);
   
   printf("\r\nCount = %u\r\n", count);
   
   while(count--)
   {
      putc(read_ext_eeprom(addy++));
   }
}

void write(void) 
{
   char str[SIZE];
   int len, i;
   int count = 0;
   int addy = 1;
   
   printf("\r\nEnter String\r\n");
   
   for(;;)
   {
      get_string_usb(str, SIZE);
      printf("\r\n");
      
      len = strlen(str);
      
      if (len == 0)
         break;
      
      i = 0;
      while(i < len)
      {
         write_ext_eeprom(addy++, str[i++]);
      }
      write_ext_eeprom(addy++, '\r');
      write_ext_eeprom(addy++, '\n');
      
      count += len + 2;
   }
   
   write_ext_eeprom(0, count);
}
