//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 21-1 #2
//
// Displays the temperature in Fahrenheit every five seconds using an external
// I2C temperature sensor.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>

#define DAL_SCL PIN_B4
#define DAL_SDA PIN_B5

#use i2c(master, sda=DAL_SDA, scl=DAL_SCL)

#include <ds1631.c>

void main(void) {
   float value;
   
   init_temp();
   
   for(;;) {
      value = read_full_temp();
      value /= 100.0;
      printf("%f\n\r", value);
      delay_ms(5000);
   }
   for(;;);
}
